import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.io.*;
import java.util.*;
import java.awt.Color;

/**
 * Write a description of class world here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class world extends World
{
    List<Vector> vectors = new ArrayList<Vector>();
    List<Wall> walls = new ArrayList<Wall>();
    /**
     * Constructor for objects of class world.
     * 
     */
    public world()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(600, 400, 1); 
        readStuff();
        Greenfoot.start();
    }
    public void act()
    {
        draw();
        rotate(0,1,0);
    }
    public void rotate(int rx,int ry, int rz)
    {
        for(int i=0;i<vectors.size();i++)
        {
            Vector v = vectors.get(i);
            double mag = Math.hypot(v.x,v.y);
            double rot = Math.atan2(v.y,v.x)+Math.toRadians(rz);
            v.x = Math.cos(rot)*mag;
            v.y = Math.sin(rot)*mag;  //rotate on the z-axis
            
            mag = Math.hypot(v.x,v.z);
            rot = Math.atan2(v.z,v.x)+Math.toRadians(ry);
            v.x = Math.cos(rot)*mag;
            v.z = Math.sin(rot)*mag;//rotate on the y-axis
            
            mag = Math.hypot(v.y,v.z);
            rot = Math.atan2(v.y,v.z)+Math.toRadians(rx);
            v.z = Math.cos(rot)*mag;
            v.y = Math.sin(rot)*mag; //rotate on the x-axis
        }
    }
    public void draw()
    {
        GreenfootImage g = getBackground();
        g.setColor(Color.white);
        g.fill();
        g.setColor(Color.red);
        double distX = 0;
        double distY = 0;
        double distZ = 8;
        for(int i=0;i<walls.size();i++)
        {
            int[] points = walls.get(i).points;
            int[] x = {
                300+(int)(200*(vectors.get(points[0]).x+distX)/(distZ+vectors.get(points[0]).z)),
                300+(int)(200*(vectors.get(points[1]).x+distX)/(distZ+vectors.get(points[1]).z)),
                300+(int)(200*(vectors.get(points[2]).x+distX)/(distZ+vectors.get(points[2]).z)),
                300+(int)(200*(vectors.get(points[3]).x+distX)/(distZ+vectors.get(points[3]).z))
            };
            int[] y = {
                200+(int)(200*(vectors.get(points[0]).y+distY)/(distZ+vectors.get(points[0]).z)),
                200+(int)(200*(vectors.get(points[1]).y+distY)/(distZ+vectors.get(points[1]).z)),
                200+(int)(200*(vectors.get(points[2]).y+distY)/(distZ+vectors.get(points[2]).z)),
                200+(int)(200*(vectors.get(points[3]).y+distY)/(distZ+vectors.get(points[3]).z))
            };
            g.drawPolygon(x,y,4);
        }
    }
    public void readStuff()
    {
        
        String text ="";
        try{
              // Open the file that is the first 
              // command line parameter
              InputStream is = world.class.getClassLoader().getResourceAsStream("Plane.obj");
              InputStreamReader ir = new InputStreamReader(is);
              BufferedReader br = new BufferedReader(ir);
              String strLine;
              //Read File Line By Line
              while ((strLine = br.readLine()) != null)   {
                text += strLine;
              }
              //Close the input stream
              is.close();
                }catch (Exception e){//Catch exception if any
              System.err.println("Error: " + e.getMessage());
              
            }
        text = text.substring(text.indexOf("v",30),text.length());
        
        CheckForVectors(text);
        CheckForWalls(text);
    }
    public void CheckForWalls(String text)
    {
        text = text.substring(text.indexOf("off")+3,text.length());
        int f = -1;
        while(text.indexOf("f",f)>-1)
        {
            String cur;
            if(text.indexOf("f",text.indexOf("f",f)+4)>-1)
                cur = text.substring(text.indexOf("f",f)+1,text.indexOf("f",text.indexOf("f",f)+4));
            else
                cur = text.substring(text.indexOf("f",f)+1,text.length());
            int space = 0;
            int[] points = new int[4];
            int note = 0;
            while(cur.indexOf(" ",space)>-1)
            {
                if(cur.indexOf(" ",cur.indexOf(" ",space)+1)>-1) 
                    points[note]= Integer.parseInt(cur.substring(cur.indexOf(" ",space)+1,cur.indexOf(" ",cur.indexOf(" ",space)+1)))-1;
                else points[note]= Integer.parseInt(cur.substring(cur.indexOf(" ",space)+1,cur.length()))-1;
                note++;
                space = cur.indexOf(" ",space)+1;
            }
            walls.add(new Wall(points));
            f = text.indexOf("f",f)+4;
        }
    }
    public void CheckForVectors(String text)
    {
        text = text.substring(0,text.indexOf("usemtl"));
        int v = 0;
        while(text.indexOf("v",v)>-1)
        {
            String cur;
            if(text.indexOf("v",text.indexOf("v",v)+7)>0) 
                cur = (text.substring(text.indexOf("v",v),text.indexOf("v",text.indexOf("v",v)+7)));
            else
                cur = text.substring(text.indexOf("v",v),text.length());
            int v2 = 0;
            //System.out.println(cur);
            int round = 0;
            double[] loc = new double[3];
            while(cur.indexOf(" ",v2)>-1)
            {
                if(cur.indexOf(" ",cur.indexOf(" ",v2)+4)>0)
                    loc[round] = Double.parseDouble(cur.substring(cur.indexOf(" ",v2)+1,cur.indexOf(" ",cur.indexOf(" ",v2)+4)));
                else
                    loc[round] = Double.parseDouble(cur.substring(cur.indexOf(" ",v2)+1,cur.length()));
                round++;
                v2 = cur.indexOf(" ",v2)+4;
            }
            vectors.add(new Vector(loc));
            v = text.indexOf("v",v)+7;
        }
    }
    public class Vector
    {
        double x,y,z;
        public Vector(double[] location)
        {
            this.x = location[0];
            this.y = location[1];
            this.z = location[2];
        }
    }
    public class Wall
    {
        int[] points;
        public Wall(int[] points2)
        {
            points = points2;
        }
    }
}
